' Focal Version 1.22
ver$ = "1.22"                 'Version Information String
focal.bat.name$ = "FOCAL"     'Focal Start-Up Batch File Name String

'Title
CLS
LOCATE 1
COLOR 15
PRINT "Focal Version "; ver$: LOCATE 1, 50: PRINT "By: All3Morph@AOL.COM"

'Check / Load Defaults from Disk
SELECT CASE ENVIRON$("DEFAULT")
     CASE "exist"
     OPEN "focal.dat" FOR INPUT AS #1
     COLOR 15
     PRINT "Using Saved Defaults..."
     INPUT #1, SCRN, XMAX, YMAX, MAXC, MAX, MIN, pal.change
     tmp = 1
     CLOSE
    
     CASE "no"
     MAX = 1000      ' Maximum Number of Lines to Draw in a Particular Color
     MIN = 100       ' Minimum Number of Lines to Draw in a Particular Color
     MAXC = 255      ' Maximum Color Attribute Number
     SCRN = 13       ' Screen Mode Numer
     XMAX = 319      ' Maximum X Value
     YMAX = 199      ' Maximum Y Value
     pal.change = 0  ' If "PAL.CHANGE" = 1 then Change Color Palette to RED!
     PRINT "Using Internal Defaults..."
    
     CASE ELSE
     CLS
     COLOR 4
     PRINT "You did not start this program properly, or you are out of enviroment"
     PRINT "space.  See your MS-DOS Documentation on how to increase your enviroment"
     PRINT "space.  To start this program properly, Type: "; : COLOR 15: PRINT focal.bat.name$
     PRINT
     SYSTEM
   
END SELECT

' User Input Routine
LOCATE 5, 1
IF tmp <> 1 THEN
PRINT "Internal Defaults Require either a VGA or MCGA Adapter and Monitor!"
END IF
tmp = 0

INPUT "Use Defaults? (Y/N)", use.def$
use.def$ = UCASE$(use.def$)

IF use.def$ = "N" THEN
PRINT
PRINT "Information for the Different Possible Answers are in your Focal Docs."
PRINT
INPUT "Change Palette?", change$: change$ = UCASE$(change$)

IF change$ = "Y" THEN
pal.change = 1
PRINT "Setting Required Variables..."
SCRN = 13: XMAX = 320: YMAX = 200: MAXC = 127
tmp = 1

ELSE

pal.change = 0

END IF

IF tmp <> 1 THEN
INPUT "SCRN Variable: ", SCRN: SCRN = INT(SCRN)
INPUT "XMAX Variable: ", XMAX: XMAX = INT(XMAX)
INPUT "YMAX Variable: ", YMAX: YMAX = INT(YMAX)
INPUT "MAXC Variable: ", MAXC: MAXC = INT(MAXC)

END IF

INPUT " MAX Variable: ", MAX: MAX = INT(MAX)
INPUT " MIN Variable: ", MIN: MIN = INT(MIN)

END IF

IF use.def$ = "N" THEN GOSUB saver

' Palette Changer Routine (If "PAL.CHANGE" = 1)
SCREEN SCRN

IF pal.change > 0 AND pal.change < 2 THEN

FOR tmp = 0 TO 63
PALETTE tmp, tmp
PALETTE tmp + 64, 63 - tmp
NEXT

END IF

' Line Graphics Routine
SCREEN SCRN

DO UNTIL INKEY$ <> ""
Count1 = Count1 + 1
E% = INT(RND(1) * XMAX) + 1
F% = INT(RND(1) * YMAX) + 1
LINE (0, 0)-(E%, F%), A%
LINE (XMAX, 0)-(E%, F%), A%
LINE (0, YMAX)-(E%, F%), A%
LINE (XMAX, YMAX)-(E%, F%), A%
IF Count1 > (INT(RND(1) * MAX - MIN) + MIN) THEN Count2 = 1
IF Count2 = 1 THEN Count1 = 0: A% = A% + 1: Count2 = 0
IF A% > MAXC THEN A% = 0
LOOP

SYSTEM

'Save Default Routine
saver:
INPUT "Save Defaults"; save.def$

save.def$ = UCASE$(save.def$)

IF save.def$ = "Y" THEN
OPEN "focal.dat" FOR OUTPUT AS #1
WRITE #1, SCRN, XMAX, YMAX, MAXC, MAX, MIN, pal.change
PRINT "Defaults Saved!"
CLOSE
END IF

RETURN

